package main

import (
	"fmt"
	"net/http"
	"os"

	"github.com/gorilla/mux"
	httpSwagger "github.com/swaggo/http-swagger"

	// API demo https://www.soberkoder.com/swagger-go-api-swaggo/
	// Use https://github.com/swaggo/swag#declarative-comments-format to format REST API
	// docs folder is generated by Swag CLI, you have to import it.
	"go-common/components/utils/logger"
	"hdar/components/hdar-api/pkg/endpoints"
	"hdar/components/hdar-api/pkg/endpoints/openapi"
)

func init() {
	// To enable client behind tls ingress
	host := fmt.Sprintf("%s", os.Getenv("SWAGGER_URL"))
	logger.Log.Infof("Swagger info to %s\n", host)
	openapi.SwaggerInfo.Host = host
	openapi.SwaggerInfo.Schemes = []string{os.Getenv("SWAGGER_SCHEMA")}
	if os.Getenv("SWAGGER_BASE_PATH") != "" {
		logger.Log.Infof("Adding Basepath %s\n", os.Getenv("SWAGGER_BASE_PATH"))
		openapi.SwaggerInfo.BasePath = os.Getenv("SWAGGER_BASE_PATH")
	}
}

// @title Hyper Distributed Applications Registry Manager
// @version 1.0
// @description Entrypoint to programatically interact with the HDAR
// @termsOfService http://swagger.io/terms/
// @contact.name Guillermo Gomez
// @contact.url https://github.gsissc.myatos.net/GLB-BDS-ETSN-SECURITY/xNF-RV-NEPHELE-HDAR/
// @contact.email guillermo.gomezchavez@eviden.net
// @license.name Eviden (ATOS business) 2023
// @tag.name default
// @tag.name internal
func main() {

	r := mux.NewRouter()
	r.PathPrefix("/swagger").Handler(httpSwagger.WrapHandler)
	r.HandleFunc("/health", endpoints.Health).Methods("GET")
	r.HandleFunc("/configure", endpoints.Configure).Methods("GET")
	r.HandleFunc("/catalogue", endpoints.Catalogue).Methods("GET")
	r.HandleFunc("/manifest/{id}", endpoints.GetConfigManifest).Methods("GET")
	r.HandleFunc("/catalogue/{id}", endpoints.DeleteRepository).Methods("DELETE")
	r.HandleFunc("/catalogue/{id}/content", endpoints.CatalogueContent).Methods("GET")
	r.HandleFunc("/catalogue/{id}/config", endpoints.GetConfigManifest).Methods("GET")
	r.HandleFunc("/catalogue/{id}/tags", endpoints.GetTags).Methods("GET")
	r.HandleFunc("/hdag", endpoints.CreateHDAG).Methods("POST")
	r.HandleFunc("/hdag/{id}", endpoints.UpdateHDAG).Methods("PUT")
	if os.Getenv("SWAGGER_BASE_PATH") != "" {
		logger.Log.Infof("Finished configuring handlers. Serving on %s://%s%s/swagger/index.html\n", os.Getenv("SWAGGER_SCHEMA"), os.Getenv("SWAGGER_URL"), os.Getenv("SWAGGER_BASE_PATH"))
	} else {
		logger.Log.Infof("Finished configuring handlers. Serving on %s://%s/swagger/index.html\n", os.Getenv("SWAGGER_SCHEMA"), os.Getenv("SWAGGER_URL"))
	}
	// Block here
	logger.Log.Fatal(http.ListenAndServe(fmt.Sprintf(":%s", os.Getenv("SWAGGER_PORT")), r))

}
